#-------------------------------------------------------
# Useful tools for the Tcl-based version of magic
#-------------------------------------------------------
# This file is included by wrapper.tcl if it is found
# in the magic install directory.
#-------------------------------------------------------

# Push and Pop---Treat the edit hierarchy like a stack.

proc magic::pushstack {name} {
   global editstack  
   if {[catch {lindex $editstack 0}]} {
      set editstack {}
   }
   lappend editstack [cellname list window]
   load $name
}

proc magic::popstack {} {
   global editstack
   load [lindex $editstack end]             
}

# Because this file is read prior to setting the magic command
# names in Tcl, we cannot run the magic commands here.  Create
# a procedure to enable the commands, then run that procedure
# from the system .magic script.

proc magic::enable_tools {} {
   # Set keystrokes for push and pop (use the macro "tag" hack. . .)
   magic::macro > "gt_cmd"
   magic::tag gt_cmd {magic::pushstack [cellname list self]}
   magic::macro < "lt_cmd"
   magic::tag lt_cmd {magic::popstack}
}
